# phpMyAdmin SQL Dump
# version 2.5.6
# http://www.phpmyadmin.net
#
# : localhost
#  :  13 2004 ., 14:15
#  : 3.23.33
#  PHP: 4.3.6
# 
#  : `calendar`
# 

# --------------------------------------------------------
#
#   `events`
#

DROP TABLE IF EXISTS events;
CREATE TABLE events (
  id int(11) NOT NULL auto_increment,
  user_id int(11) NOT NULL default '0',
  event_date date NOT NULL default '0000-00-00',
  start_time time NOT NULL default '00:00:00',
  end_time time NOT NULL default '00:00:00',
  description text NOT NULL,
  period varchar(10) NOT NULL default '0',
  daily varchar(10) NOT NULL default '0',
  subvalue varchar(50) NOT NULL default '',
  end_event_date date NOT NULL default '0000-00-00',
  PRIMARY KEY (id)
) TYPE=MyISAM;

# --------------------------------------------------------

#
#   `help`
#

DROP TABLE IF EXISTS help;
CREATE TABLE help (
  id int(10) NOT NULL auto_increment,
  zone varchar(10) NOT NULL default '',
  menu_id int(11) NOT NULL default '0',
  msg text NOT NULL,
  PRIMARY KEY (id)
) TYPE=MyISAM;

# --------------------------------------------------------

#
#   `preferences`
#

DROP TABLE IF EXISTS preferences;
CREATE TABLE preferences (
  id int(11) NOT NULL auto_increment,
  field varchar(150) NOT NULL default '',
  value text NOT NULL,
  title varchar(100) NOT NULL default '',
  field_group varchar(150) NOT NULL default '',
  type varchar(255) NOT NULL default '',
  help text NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY id(id)
) TYPE=MyISAM;

# --------------------------------------------------------

#
#   `templates`
#

DROP TABLE IF EXISTS templates;
CREATE TABLE templates (
  id int(11) NOT NULL auto_increment,
  tmpl text NOT NULL,
  type varchar(20) NOT NULL default '',
  user_group varchar(10) NOT NULL default '',
  PRIMARY KEY (id),
  UNIQUE KEY id(id)
) TYPE=MyISAM;

# --------------------------------------------------------

#
#   `users`
#

DROP TABLE IF EXISTS users;
CREATE TABLE users (
  id int(11) NOT NULL auto_increment,
  login varchar(50) NOT NULL default '',
  password varchar(50) NOT NULL default '',
  email varchar(100) NOT NULL default '',
  first_name varchar(50) NOT NULL default '',
  last_name varchar(50) NOT NULL default '',
  register_date date NOT NULL default '0000-00-00',
  status int(1) NOT NULL default '0',
  is_admin int(11) NOT NULL default '0',
  PRIMARY KEY (id),
  UNIQUE KEY key_id(id)
) TYPE=MyISAM;

#
#    `help`
#

INSERT INTO help VALUES (1, 'user', 60, 'This section serves for searching events. Just pick up proper time period in <b><u>Select period</u></b> section. There are four buttons to the right (<b><u>this day, this week, this month, this year</u></b>) which will help you settle down the right period, but remember that they work only concerning current year. If you are interested in some other years you can pick them up in listboxes near start date and end date. If you want to find particular event or event for some particular period of time mark checkbox(s) near <b><u>Search Time</u></b> or <b><u>Search Description</u></b> and pick up required time or insert description. Don\'t forget to press <b><u>Go</u></b> button. The result of your search will be shown in <b><u>Events list</u></b> section. You can get more information about any event or day, change or delete some event if you press require link (of the day or event).');
INSERT INTO help VALUES (2, 'user', 50, 'In this section you can look through all events which are already located in your calendar. In the right corner you can see four buttons with the help of which you can decide through what period of time you want to look. Just set cursor on the any button you like and you\'ll see help text.<br>\r\nThe process of navigation in <b><u>Calendar</u></b> section as in other section of Magic Calendar is realized with the help of arrows. (These arrows also have help text).<br>\r\n<b><u>Add</u></b> button will help you if you want to add some more events into Magic Calendar, after pressing it you\'ll be redirected to the <b><u>Settings</u></b> section.<br>\r\n<b><u>Daily view</u></b> This page is represented by the hourly planning of the day. Each hour in its\' turn is divided into four section (quarters of an hour). Every event that has ever been added into the Magic Calendar can be found in this table. To know more about any of the events given in the table, to change or delete something, please click link of this event and you\'ll be redirected to the new window which allows you to realize these actions.<br>\r\nOn <b><u>Week view page</u></b> you can see table, in which is given information about hourly planning of every week\'s day. If you want to look through another week\'s plans use arrows. By clicking link of any event here, you\'ll be redirected to the same window as in <b><u>Daily view</u></b> section. If you set cursor to the link of one particular day you\'ll be redirected to <b><u>Daily view</u></b> page<br>\r\n<b><u>Mouth view</u></b> represents monthly planning. It works the same way as previous section do. By setting cursor to the link of the date you\'ll be redirected to <b><u>Daily view</u></b> page. If you set cursor to the link of the time period, you\'ll be redirected to the window which gives you more thorough description of this event.<br>\r\n<b><u>Year view</u></b> is represented by the table which makes it possible to see plan for the whole year. Days\' cells filled with point show that for this day is already settled one or some events. There are cells on the month\'s field which are differently colored - they are staying for days that belong to the previous or next month. Bright colored cell denotes present day.<br>\r\nAs for the rest this page works the same way as previous sections do. It\'s enough just to click mouth\'s link to be redirected to the <b><u>Mouth View</u></b> page and day\'s cell to open <b><u>Daily View</u></b> page.\r\n');
INSERT INTO help VALUES (3, 'admin', 10, 'Where is some help about menu items<br>\r\n<b>Calendar</b> - In this section you can look through all events which are already located in your calendar<br>\r\n<b>Events</b> - In this section you can manage your events. Add new or edit existing events.<br>\r\n<b>Event list</b> - This section serves for searching events<br>\r\n<b>Settings</b> - In Settings section should be fulfilled all those settings which allow you to use Magic Calendar Lite to the best advantage<br>\r\n<b>Logout</b> - serves for going out of the Magic Calendar.<br>');
INSERT INTO help VALUES (9, 'user', 10, 'Where is some help about menu items<br>\r\n<b>Calendar</b> - In this section you can look through all events which are already located in your calendar<br>\r\n<b>Event list</b> - This section serves for searching events');
INSERT INTO help VALUES (4, 'admin', 50, 'This section serves for searching events. Just pick up proper time period in <b><u>Select period</u></b> section. There are four buttons to the right (<b><u>this day, this week, this month, this year</u></b>) which will help you settle down the right period, but remember that they work only concerning current year. If you are interested in some other years you can pick them up in listboxes near start date and end date. If you want to find particular event or event for some particular period of time mark checkbox(s) near <b><u>Search Time</u></b> or <b><u>Search Description</u></b> and pick up required time or insert description. Don\'t forget to press <b><u>Go</u></b> button. The result of your search will be shown in <b><u>Events list</u></b> section. You can get more information about any event or day, change or delete some event if you press require link (of the day or event).');
INSERT INTO help VALUES (5, 'admin', 30, 'In this section you can look through all events which are already located in your calendar. In the right corner you can see four buttons with the help of which you can decide through what period of time you want to look. Just set cursor on the any button you like and you\'ll see help text.<br>\r\nThe process of navigation in <b><u>Calendar</u></b> section as in other section of Magic Calendar is realized with the help of arrows. (These arrows also have help text).<br>\r\n<b><u>Add</u></b> button will help you if you want to add some more events into Magic Calendar, after pressing it you\'ll be redirected to the <b><u>Settings</u></b> section.<br>\r\n<b><u>Daily view</u></b> This page is represented by the hourly planning of the day. Each hour in its\' turn is divided into four section (quarters of an hour). Every event that has ever been added into the Magic Calendar can be found in this table. To know more about any of the events given in the table, to change or delete something, please click link of this event and you\'ll be redirected to the new window which allows you to realize these actions.<br>\r\nOn <b><u>Week view page</u></b> you can see table, in which is given information about hourly planning of every week\'s day. If you want to look through another week\'s plans use arrows. By clicking link of any event here, you\'ll be redirected to the same window as in <b><u>Daily view</u></b> section. If you set cursor to the link of one particular day you\'ll be redirected to <b><u>Daily view</u></b> page<br>\r\n<b><u>Mouth view</u></b> represents monthly planning. It works the same way as previous section do. By setting cursor to the link of the date you\'ll be redirected to <b><u>Daily view</u></b> page. If you set cursor to the link of the time period, you\'ll be redirected to the window which gives you more thorough description of this event.<br>\r\n<b><u>Year view</u></b> is represented by the table which makes it possible to see plan for the whole year. Days\' cells filled with point show that for this day is already settled one or some events. There are cells on the month\'s field which are differently colored - they are staying for days that belong to the previous or next month. Bright colored cell denotes present day.<br>\r\nAs for the rest this page works the same way as previous sections do. It\'s enough just to click mouth\'s link to be redirected to the <b><u>Mouth View</u></b> page and day\'s cell to open <b><u>Daily View</u></b> page.\r\n');
INSERT INTO help VALUES (6, 'admin', 40, 'There are two ways to add events to the magic calendar: simple and advanced. Pick up the proper one you can in <b><u>Settings</u></b> section.<br>\r\nIf you\'ve chosen <b><u>Simple</u></b> way you should pick up proper date, start and end time of the event at first, then insert description of the event to the <b><u>Description</u></b> field. By pressing proper radiobutton, you may pick up proper interval for your events; it means that you can decide whether your event will be given one time only, monthly, daily etc. If you\'ve chosen <b><u>Daily</u></b> interval, pay attention that your event may be shown all days (<b><u>All Days</u></b> radiobutton) or in some particular days (<b><u>one or more days each week</u></b> radiobutton). Proper day can be chosen by marking proper day of the week checkbox.<br>\r\n<b><u>End date of event</u></b> Pay attention that if you don\'t pick up proper date here, by default will be given date which is given in <b><u>Date of event</u></b> section, it means that your event will exist in <b><u>Magic Calendar</u></b> only one day.<br>\r\nDon\'t forget to press <b><u>Add</u></b> button having all your settings done.<br>\r\nIf you\'ve chosen <b><u>Advanced</u></b> mode to all simple mode functions will be added extra fields which will help you to customize time intervals more accurately. You can decide whether your event will be shown all days long or only during weekdays or weekends (just press required radiobutton). If you want your event to be shown one or more days each week mark checkbox(s) near proper days. You may customize <b><u>Magic Calendar</u></b> in such a way that your event will be shown same day during some period of time. There are two radiobuttons near <b><u>"Some week of every adjusted month"</u></b> and <b><u>"Every adjusted week(s)"</u></b>. Press the one you need and customize interval of event the way you like. Don\'t forget that day that when event will be shown is settled in <b><u>Date of event</u></b> section. Having all your settings finished don\'t forget to press <b><u>Add</u></b> button.<br>\r\n');
INSERT INTO help VALUES (7, 'admin', 50, 'This section serves for searching events. Just pick up proper time period in <b><u>Select period</u></b> section. There are four buttons to the right (<b><u>this day, this week, this month, this year</u></b>) which will help you settle down the right period, but remember that they work only concerning current year. If you are interested in some other years you can pick them up in listboxes near start date and end date. If you want to find particular event or event for some particular period of time mark checkbox(s) near <b><u>Search Time</u></b> or <b><u>Search Description</u></b> and pick up required time or insert description. Don\'t forget to press <b><u>Go</u></b> button. The result of your search will be shown in <b><u>Events list</u></b> section. You can get more information about any event or day, change or delete some event if you press require link (of the day or event).');
INSERT INTO help VALUES (8, 'admin', 60, 'On the top of <b><u>Settings</u></b> section you can see <b><u>Change administrator\'s password</u></b> link, if you want to change password just click it and you\'ll be redirected to the popup where you should insert your old password, new one and one more time new password for confirmation. After it don\'t forget to press <b><u>Update</u></b> button.<br>\r\nIn <b><u>Settings</u></b> section should be fulfilled all those settings which allow you to use Magic Calendar Lite to the best advantage.<br>\r\nTo the <b><u>Script dir</u></b> field should be inserted path to the directory in which Magic Calendar Lite will be situated.<br>\r\nPut e-mail that will be used as administrator e-mail to the <b><u>Admin e-mail</u></b> section. All messages that are assigned to the administrator will come to this e-mail.<br>\r\nTo the <b><u>Script URL</u></b> section put URL where Magic Calendar Lite will be situated.<br>\r\nCheckbox near <b><u>Simple Mode</u></b> determines what kind of form: simple or advanced will be given in the events section for adding events to the calendar.<br>\r\n<b><u>Users start page</u></b> - place here HTML code for the home page of user\'s zone<br>\r\n<b><u>Active template</u></b> - here you can pick up template that will be used for outputting Magic calendar on your site.<br>\r\n<b><u>Upload logo</u></b> section is used when you want to change "Reamday" logo to your own, just press <b><u>Browse</u></b> button and pick up any suitable logo from your computer, but remember that size of this image should be 231x59 pixels otherwise your image will be made to measures by the program, this change of the sizes may adversely affect outlook of your image.<br>\r\nHaving everything finished, don\'t forget to press <b><u>Update</u></b> button.<br>\r\n');

#
#    `preferences`
#

INSERT INTO preferences VALUES (1, 'script_dir', 'd:/www/calendar', 'Script dir', 'Settings', 'text', '');
INSERT INTO preferences VALUES (2, 'admin_email', '', 'Admin e-mail', 'Settings', 'text', '0');
INSERT INTO preferences VALUES (3, 'script_url', 'http://ss/calendar', 'Script url', 'Settings', 'text', '');
INSERT INTO preferences VALUES (64, 'user_start_page', '<TABLE border="0" height=\'70\' width="100%" bgcolor="#FFFFFF">\r\n<TR>\r\n	<TD align=middle bgColor=white><H1>Welcome to MagicCalendar</H1></TD>\r\n</TR>\r\n</table>\r\n\r\n<TABLE border="0" height=\'80\' width="100%" bgcolor="#FFFFFF">\r\n<TR>\r\n	<td width="30">&nbsp;</td>\r\n	<TD valign=\'top\' width=\'580\' align=left>\r\n		<p align=justify>\r\n			<table border=0 width=80 align=left>\r\n			<tr><td>\r\n			<center>\r\n				<font face=Tahoma size=1 >\r\n			<img src="http://reamdaysoft.com/boxes/mnp_80x80.jpg">\r\n\r\n			</td></tr>\r\n			</table>\r\n		<div style="margin-top:5">\r\n		 <a href="http://reamdaysoft.com" style="text-decoration:none" target="_blank"><font color="#000000"><b>Reamdeay Enterprises</b></font></a> is glad to present its\' news product <a href="http://reamdaysoft.com/magic-news-plus.html" style="text-decoration: none" target="_blank"><b>Magic News Plus</b></a>! Great variety of <a href="http://reamdaysoft.com/news-script-features.html" style="text-decoration:none" target="_blank">features and functions</a> makes this program really irreplaceable for those who deals or going to deal with news management.\r\n		</div>\r\n		</p>\r\n	</TD>\r\n</TR>\r\n<TR>\r\n	<td width="30">&nbsp;</td>\r\n	<TD valign=\'top\' width=\'580\' align=left>\r\n		<p align=justify>\r\n			<table border=0 width=80 align=left>\r\n			<tr><td>\r\n			<center>\r\n				<font face=Tahoma size=1 >\r\n			<img src="http://reamdaysoft.com/boxes/mfm_80x80.jpg">\r\n\r\n			</td></tr>\r\n			</table>\r\n		<div style="margin-top:5">\r\n		Our new product <a href="http://reamdaysoft.com/magic-form-mail.html" style="text-decoration: none" target="_blank"><b>Magic Form Mail</b></a> is available now! We\'ve finished working at it and happy to offer the <a href="http://reamdaysoft.com/magic-form-mail.html" target="_blank">result</a> of our work to you.\r\n		</div>\r\n		</p>\r\n	</TD>\r\n</TR>\r\n<TR>\r\n	<td width="30">&nbsp;</td>\r\n	<TD valign=\'top\' width=\'580\' align=left>\r\n		<p align=justify>\r\n			<table border=0 width=80 align=left>\r\n			<tr><td>\r\n			<center>\r\n				<font face=Tahoma size=1 >\r\n			<img src="http://reamdaysoft.com/boxes/md_80x80.jpg">\r\n\r\n			</td></tr>\r\n			</table>\r\n		<div style="margin-top:5">\r\n		<a href="http://reamdaysoft.com" style="text-decoration:none" target="_blank"><font color="#000000"><b>Reamdeay Enterprises</b></font></a> is proud to announce realease of <a href="http://reamdaysoft.com/magic_downloads.html" style="text-decoration: none" target="_blank"><b>Magic Downloads</b></a> - easy and useful downloads manager system.Here you can find a lot of useful features, neat design and the easiest management, as it is the way with us. Please checkout <a href="http://reamdaysoft.com/magic_downloads.html" target="_blank">detailed info and screenshots</a>.\r\n		</div>\r\n		</p>\r\n	</TD>\r\n</TR>\r\n<TR>\r\n	<td width="30">&nbsp;</td>\r\n	<TD valign=\'top\' width=\'580\' align=left>\r\n		<p align=justify>\r\n			<table border=0 width=80 align=left>\r\n			<tr><td>{small_calendar}</td></tr>\r\n			</table>\r\n		<div style="margin-top:5">\r\n		Additional feature. You can include this small calendar into your site. \r\n			Write code:<BR><INPUT type="text" class="small-text" value="include(\'{script_url}/view_small_calendar.php\');" style="width:350px">\r\n		</div>\r\n		</p>\r\n	</TD>\r\n</TR>\r\n</TABLE>', 'Users start page', 'Settings', 'textarea', '');
INSERT INTO preferences VALUES (62, 'template_full', 'http://ss/calendar/templates/main', '', 'Settings', 'text', '');
INSERT INTO preferences VALUES (63, 'simple_user', '0', 'Simple Mode', 'Settings', 'checkbox', '');
INSERT INTO preferences VALUES (61, 'template', './templates/main', '', 'Settings', 'text', '');

#
#    `templates`
#

INSERT INTO templates VALUES (7, '<center>\r\n<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">\r\n<tr>\r\n	<td width="50%" bgcolor="#CCCCCC" height=100% align="center" valign=top>\r\n	<center>\r\n	<table border=0 cellpadding=0 cellspacing="0" width="50%" height="100%">\r\n	<tr>\r\n		<td>\r\n		<table border=0 width="100%" cellpadding=0 cellspacing="0" background="images/design/top_bg.gif">\r\n		<tr>\r\n			<td width="100%" height="59" align="left" valign=middle><a href="http://reamdaysoft.com/magic-calendar-lite.html" target="_blank"><img src="images/design/title.gif" border=0 width=324 alt="MagicCalendarLite"></a></td>\r\n			<td width="100%" height="59"><img src="images/design/top_bg.gif" border=0></td>\r\n			<td width="100%" align=right valign=middle><a href="http://reamdaysoft.com" target="_blank"><img src="images/design/logo.gif" border=0 width="231" height="47" alt="Reamday Enterprises: web development company"></a></td>\r\n			<td width="13" height="59" align="right" valign="middle"><img src="images/design/top_end.gif" width="13" border="0" height="59"></td>\r\n		</tr>\r\n		</table>\r\n		</td>\r\n	</tr>\r\n	<tr>\r\n		<td>\r\n		<table border=0 width="100%" cellpadding=0 cellspacing="0" background="images/design/bg1.gif">\r\n		<tr>\r\n			<td width="9" height="31" align=left valign=middle><img src="images/design/img1_1.gif" border=0 width=9></td>\r\n			<td width="11" height="31" valign=middle><img src="images/design/resh.gif" border=0 width=11></td>\r\n			<td width="100%" height="31" valign=middle>\r\n			<table border=0 cellpadding=3 cellspacing="0">\r\n			<tr>\r\n				<td>\r\n				<font class="menu-font">#%MENUITEM%#</font>\r\n				</td>\r\n			</tr>\r\n			</table>\r\n			</td>\r\n			<td width="47" align="right" valign=middle><img src="images/design/img1_3.gif" border=0 width=47></td>\r\n		</tr>\r\n		</table>\r\n		</td>\r\n	</tr>\r\n	<tr>\r\n		<td>\r\n		<table border=0 width="100%" cellpadding=0 cellspacing="0" background="images/design/bg2.gif">\r\n		<tr>\r\n			<td width="9" height="21" align=left valign=middle><img src="images/design/img2_1.gif" border=0 width=9></td>\r\n			#%MENU_LEVEL%#\r\n			<td width="100%" height="21" valign=middle><img src="images/design/bg2.gif" border=0></td>\r\n			<td width="25" align="right" valign=middle><img src="images/design/img2_3.gif" border=0 width=25></td>\r\n		</tr>\r\n		</table>\r\n		</td>\r\n	</tr>\r\n\r\n	<tr>\r\n		<td height="100%" bgcolor="#FFFFFF">\r\n		<table border=0 width=720 height="100%" cellpadding=0 cellspacing="0">\r\n		<tr>\r\n			<td width="9" height="100%" align=left valign=top background="images/design/bg3.gif"><img src="images/design/bg3.gif" border=0 width=9></td>\r\n			<td width="100%" height="100%" align=left valign=top>\r\n			<!-- MAIN -->\r\n			<table border=0 width=100% cellpadding="3" cellspacing="1" height="100%" cellpadding=0 cellspacing="0">\r\n			<!-- INSTRUCTIONS -->\r\n			<tr>\r\n				<td width="100%" align=center valign=top>\r\n				<table border=0 width=100% cellpadding=0 cellspacing="0">\r\n				<tr>\r\n					<td width="3" height="3" align=left valign=center background="images/design/tab_bg_1.gif"><img src="images/design/tab_1.gif" border=0 width=3 height=3></td>\r\n					<td width="100%" height="3" align=left valign=center background="images/design/tab_bg_1.gif"><img src="images/design/tab_bg_1.gif" border=0></td>\r\n					<td width="3" height="3" align="right" valign=center><img src="images/design/tab_2.gif" border=0 width=3></td>\r\n				</tr>\r\n				<tr>\r\n					<td width="3" align=left valign=center background="images/design/tab_bg_2.gif"><img src="images/design/tab_bg_2.gif" border=0 width=3 height=3></td>\r\n					<td width="90%" align=left valign=center bgcolor="#F7F7F7">\r\n					<table border=0 width=100% cellpadding=0 cellspacing="0">\r\n					<tr>	\r\n						<td width="100%">\r\n						<table border=0 cellpadding=3 cellspacing="0">\r\n						<tr>\r\n							<td><font class="menu-font">Instructions</font></td>\r\n						</tr>\r\n						</table>\r\n						</td>\r\n						<td width="16" height="16"><a href="#%hrefmsghide%#"><img src="images/design/s_up.gif" border=0 width="16" height="16"></a></td>\r\n						<td width="16" height="16"><a href="#%hrefmsgshow%#"><img src="images/design/s_down.gif" border=0 width="16" height="16"></a></td>\r\n					</tr>\r\n					#%line%#\r\n						</font>\r\n						</td>\r\n					</tr>\r\n					</table>\r\n					</td>\r\n					<td width="3" height="100%" align="right" valign=center background="images/design/tab_bg_3.gif"><img src="images/design/tab_bg_3.gif" border=0 width=3></td>\r\n				</tr>\r\n				#%helpmsg%#\r\n				<tr>\r\n					<td width="3" height="3" align=left valign=center background="images/design/tab_bg_4.gif"><img src="images/design/tab_3.gif" border=0 width=3 height=3></td>\r\n					<td width="100%" height="3" align=left valign=center background="images/design/tab_bg_4.gif"><img src="images/design/tab_bg_4.gif" border=0></td>\r\n					<td width="3" height="3" align="right" valign=center><img src="images/design/tab_4.gif" border=0 width=3></td>\r\n				</tr>\r\n				</table>\r\n				</td>\r\n			</tr>\r\n			<!-- END INSTRUCTIONS -->\r\n			<!-- MAIN INFORMATION -->\r\n			<tr>\r\n				<td width="100%" height="100%" align=center valign=top>\r\n				<table border="0" width="100%" height="100%" cellpadding="0" cellspacing="0">\r\n				<tr>\r\n					<td width="3" height="3" align=left valign=center background="images/design/tab_bg_1.gif"><img src="images/design/tab_1.gif" border=0 width=3 height=3></td>\r\n					<td width="100%" height="3" align=left valign=center background="images/design/tab_bg_1.gif"><img src="images/design/tab_bg_1.gif" border=0></td>\r\n					<td width="3" height="3" align="right" valign=center><img src="images/design/tab_2.gif" border=0 width=3></td>\r\n				</tr>				\r\n				<tr>\r\n					<td width="3" height="100%" align=left valign=center background="images/design/tab_bg_2.gif"><img src="images/design/tab_bg_2.gif" border=0 width=3 height=3></td>\r\n					<td width="100%" height="100%" align=left valign=top bgcolor="#F7F7F7">#%TEXT%#</td>\r\n					<td width="3" height="100%" align="right" valign=center background="images/design/tab_bg_3.gif"><img src="images/design/tab_bg_3.gif" border=0 width=3></td>\r\n				</tr>\r\n				<tr>\r\n					<td width="3" height="3" align=left valign=center background="images/design/tab_bg_4.gif"><img src="images/design/tab_3.gif" border=0 width=3 height=3></td>\r\n					<td width="100%" height="3" align=left valign=center background="images/design/tab_bg_4.gif"><img src="images/design/tab_bg_4.gif" border=0></td>\r\n					<td width="3" height="3" align="right" valign=center><img src="images/design/tab_4.gif" border=0 width=3></td>\r\n				</tr>\r\n				</table>\r\n				</td>\r\n			</tr>\r\n			<!-- END MAIN INFORMATION -->\r\n			</table>\r\n			<!-- END MAIN -->\r\n			</td>\r\n			<td width="15" height="100%" align="right" valign=top background="images/design/bg5_1.gif"><img src="images/design/img4_4.gif" border=0 width=15 height="15"></td>\r\n		</tr>\r\n		</table>\r\n		</td>\r\n	</tr>\r\n	<tr>\r\n		<td>\r\n		<table border=0 width="100%" height="33" cellpadding=0 cellspacing="0" background="images/design/bg7.gif">\r\n		<tr>\r\n			<td width="9" height="33" align=left valign=center background="images/design/bg3.gif"><img src="images/design/bot_1.gif" border=0 width=9></td>\r\n			<td width="13" height="33" align=left valign=center background="images/design/bg3.gif"><img src="images/design/resh_bot.gif" border=0 width=13></td>\r\n			<td width="100%" height="33" align=left valign=center background="images/design/bg7.gif"><a href="http://reamdaysoft.com" class="copyright" target="_blank"><font class="bot-font">&nbsp;&copy;&nbsp;Reamday Enterprises: web development company, 2004</font></a></td>\r\n			<td width="25" height="33" align="right" valign=center><img src="images/design/bot_3.gif" border=0 width=25></td>\r\n		</tr>\r\n		</table>\r\n		</td>\r\n	</tr>\r\n	</table>\r\n	</td>\r\n</tr>\r\n<tr>\r\n	<td bgcolor="#CCCCCC">\r\n<CENTER>\r\n<font class="small-font"><br>Copyright  &copy; <a href="http://reamdaysoft.com" target="_blank">Reamday Enterprises</a>, 2004<br>Get free support on Magic Calendar Lite @ <a href="http://www.webdevelopmenthelp.biz" target="_blank">www.webdevelopmenthelp.biz</a></font>\r\n</CENTER>\r\n	</td>\r\n</tr>\r\n</table>\r\n</BODY>\r\n</HTML>\r\n', 'main', 'admin');
INSERT INTO templates VALUES (8, '<td height="21" valign=middle><a href="#%SCRIPT%#"><img src="images/menu/#%MENUIMG%#" border=0 alt="#%MENU%#"></a></td>', 'menu', 'admin');
INSERT INTO templates VALUES (9, '<TD NOWRAP valign="top">#%MENU2%#</TD>', 'menu2', 'admin');
