unit SimpleMain;

interface

uses
  SysUtils, Forms,
  xorDX8;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Scene: TxorDXScene;
    Camera: TxorDXCamera;
    Rect: TxorDXRect;
    procedure Draw(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }
        
procedure TForm1.FormCreate(Sender: TObject);
begin
  xorDXThrowAllOtherExceptions := True;
  xorDXThrowCameraTransformationExceptions := False;
  xorDXThrowIndexSizeException := True;
  xorDXThrowCapsException := True;
  //creation
  Scene := TxorDXScene.Create(Handle);
  Camera := TxorDXCamera.Create(Scene);
  Rect := TxorDXRect.Create(Scene, 30, 15, 9, 5);
  Scene.CreateBuffers;

  //settings & start
  Rect.MoveCenter(True);
  Camera.SetStandard;
  Camera.Ratio := Width / Height;
  Scene.OnDraw := Draw;
  Scene.StartLooping;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //free in inverted order of creation
  FreeAndNil(Rect);
  FreeAndNil(Camera);
  FreeAndNil(Scene);
end;

//repeated drawing routine
procedure TForm1.Draw(Sender: TObject);
begin
  Scene.Clear;
  Camera.UndoTransformation; //return to standard view
  Camera.RotateHoriz(Sin(RotationsPerSecond(0.02)), xorDXCamHuman); //rotate horizontal between 1, -1 and back all 50 seconds
  Camera.Activate;
  Rect.Insert;
  Rect.RotateX(-0.01);
  Rect.Draw;
end;

initialization

  InitRotationPerSecond;

end.
