unit xycommon;

{=========================================================================}
{ See Copyright notes at XYGRAPH.                                         }
{=========================================================================}

interface

uses Windows , {Messages,} SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    {StdCtrls, Spin,} ExtCtrls, Clipbrd{, AppEvnts};

{ these procedures and variables are to be used by XYGRAPH and XYGRAPH3D}
{ do not call them directly }

function mixcolor(cl1,cl2:Tcolor;f1,f2 : integer):Tcolor;
function reversecolor(cl:integer):integer;

procedure copyscreen(mode:integer);
procedure restorescreen;

procedure printpart(x1,y1,x2,y2:integer);
procedure store;
procedure restore;
procedure setcursor(xp,yp:integer);
procedure xypixel(xp,yp:integer;col:Tcolor);
procedure xyrectangle(col1,col2,x1,y1,x2,y2:integer);
procedure xyline(col,x1,y1,x2,y2:integer);
procedure xypolygon(col1,col2:integer;poly:array of Tpoint);
procedure transpolygon(col1,col2:integer;poly:array of Tpoint);
procedure xycircle(col1,col2,x,y,r:integer);
procedure transcircle(col1,col2,x,y,r:integer);

procedure initwmf;
procedure openwmf(var s:string;var ok:boolean);
procedure closewmf(var ok:boolean);
procedure initgrid;
procedure dogrid(p1,p2:integer;xas:boolean);
procedure checkwmfrgpen;
procedure checkwmfpen;
procedure wmfredpen;
procedure wmfgrnpen;
procedure checkwmfbrush;
procedure checkwmffont;
procedure linewmf(x1,y1,x2,y2:integer);
procedure blokwmf(x1,y1,x2,y2:integer);
procedure ellipsewmf(x1,y1,x2,y2:integer);
procedure rop2wmf(n:integer);
procedure polygonwmf(points: array of Tpoint);
procedure addfine(p:integer);
procedure addcoarse(p:integer);
procedure pixelwmf(x,y:integer; col:Tcolor);
procedure movewmf(x,y:integer);
procedure drawwmf(x,y:integer);
procedure textwmfalign(n:integer);
procedure textwmfout(x,y:integer;s:string);
procedure bitmapwmf(x1,y1,x2,y2:integer);

const maxgraf = 8;

var xycanvas : Tcanvas;
    xypaintbox : Tpaintbox;
    frontcolor, backcolor : Tcolor;   {default kleuren}
    oldfcolor, oldbcolor : Tcolor;     { idem }
    dowmf, doprint : boolean;         {bezig met metafile of print}
    useroff : boolean;                {user coord uitgeschakeld}
    mode3d : boolean;                 {3D mode}
    igraph, ngraph : integer;         {actuele grafiek, aantal grafieken}
    res : integer;                    {resolutie}
    oldpen : Tpen;                    {vorige pen}
    oldbrush : Tbrush;                {vorige brush}
    cwidth, cheight : integer;        {afmetingen canvas}
    cvmode : boolean;                 {canvas mode}
    xyfontangle : integer;            {hoek van font}
    transmode : integer;              {transparancy mode}
    transval : single;                {transparancy level}
    transopt : integer;               {transparancy options}
    prxoff,pryoff : integer;          {printer offset}
    prfac :integer;                   {printer factor}
    prshow : boolean;                 {toon voortgang}
    crsok : boolean;                  {mag crs maken}
    polartype : integer;              {polaire coordinaten: 0 = cart
                                        1=pol 2=radar 3-cyl}
    stereo : boolean;                 {stereo aan rood/groen}
    ffac : single;                    {correctiefactor fonts}
    xoff,yoff : integer;              {offset}
    linestyle : integer;              {line style, <0=none, 0=solid, >0 = dash}
    stereocol : array[0..2] of Tcolor; {kleur}

type symboltype = record
                   xp,yp:word;
                   style,size,fill,width,cd3d : byte;
                   color,cl1,cl2,cl3:Tcolor;
                 end;
var  lastsymbol : symboltype;         {laatst gemelde xysymbol}

     screencopy : Tbitmap;            {kopie van beeldscherm}

var graphfield, plotfield : record x1,x2,y1,y2 : integer; end;

implementation

{$I-}

uses xygraph, printers;

var ff : file;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXX EX COMMON XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

function red(cl:Tcolor):integer;
begin red := colortorgb(cl) shr 0 and $FF; end;

function green(cl:Tcolor):integer;
begin green := colortorgb(cl) shr 8 and $FF; end;

function blue(cl:Tcolor):integer;
begin blue := colortorgb(cl) shr 16 and $FF; end;

function mixcolor(cl1,cl2:Tcolor;f1,f2 : integer):Tcolor;
begin
  if (f1<0) or (f2<0) or (f1+f2=0) then begin mixcolor := clblack; exit; end;
  mixcolor :=
   ( ( red(cl1) * f1 + red(cl2) * f2 ) div (f1+f2) ) and $FF shl 0 +
   ( ( green(cl1) * f1 + green(cl2) * f2 ) div (f1+f2) ) and $FF shl 8 +
   ( ( blue(cl1) * f1 + blue(cl2) * f2 ) div (f1+f2) ) and $FF shl 16;
end;

function reversecolor(cl:integer):integer; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{kleur omkeer RGB -> BGR voor direct mem}
begin
  result := (cl and $FF00)
         or (cl and $FF) shl 16
         or (cl and $FF0000) shr 16 ;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{maskblt bitblt stretchblt setrop2 getrgnbox selectcliprgn}

procedure transparent(h:Thandle;col:tcolor;edge:boolean); {XXXXXXXXXXXXXXXXXXXX}
var r,g,b,tr,f1,f2,x0,y0,x1,y1,wi,he,x,y,yy,xp,t : integer;
    rect : Trect;
    bm : Tbitmap;
    p : Pbytearray;
    oy,ok : boolean;
begin
  r := col and $ff; g := col shr 8 and $ff; b := col shr 16 and $ff;

  tr := round(transval*8);
  if (tr<0) then tr := 0 else if (tr>8) then tr := 8;
  f1 := 256*(8-tr); f2 := tr;

  t := getrgnbox(h,rect); if (t=0) or (t=nullregion) then exit;
  with rect do
    begin x0 := left; y0 := top; x1 := right-1; y1 := bottom-1; end;
  {if edge then begin inc(x0); inc(y0); end;}
  if (x0>cwidth) or (y0>cheight) or (x1<0) or (y1<0) then exit;
  if (x0<0) then x0 := 0; if (x1>cwidth) then x1 := cwidth;
  if (y0<0) then y0 := 0; if (y1>cheight) then y1 := cheight;
  he := y1-y0+1; wi := x1-x0+1;
  if (he<1) or (wi<1) then exit;

  bm := Tbitmap.create; bm.pixelformat := pf24bit;
  bm.width := wi; bm.height := he;
  if not bitblt(bm.canvas.handle,0,0,wi,he,xycanvas.handle,x0,y0,srccopy)
    then begin bm.free; exit; end;

  if (transmode=2) then {echte transparancy}

  for y := 0 to he-1 do
    begin
      p := bm.scanline[y]; yy := y+y0; xp := 0;
      for x := x0 to x0+wi-1 do if ptinregion(h,x,yy) then
        begin
          p[xp] := (b * (f1+p[xp]*f2)) shr 11; inc(xp);
          p[xp] := (g * (f1+p[xp]*f2)) shr 11; inc(xp);
          p[xp] := (r * (f1+p[xp]*f2)) shr 11; inc(xp);
        end else inc(xp,3);
    end

  else {quasi transparancy}

  for y := 0 to he-1 do
    begin
      p := bm.scanline[y]; yy := y+y0; xp := 0; oy := odd(yy);
      for x := x0 to x0+wi-1 do
       if ((odd(x) xor oy) and ptinregion(h,x,yy) ) then
         begin
           p[xp] := b; inc(xp);
           p[xp] := g; inc(xp);
           p[xp] := r; inc(xp);
         end else inc(xp,3);
    end;

  bitblt(xycanvas.handle,x0,y0,wi,he,bm.canvas.handle,0,0,srccopy);
  bm.free;
end;

procedure drawtransparent(x,y,r:integer;poly:array of Tpoint); {XXXXXXXXXXXXXXX}
var mode,col1,col2 : integer;
    h : Thandle;
    edge : boolean;
begin
  if length(poly)>1 then mode := 2
  else if (r>0) then mode := 1
  else exit;

  col2 := xybrush.color; col1 := xypen.color; h := 0;
  edge := (col1<>col2) or (transopt and 2 > 0);

  if (dowmf) then {alleen transmode=1}
    begin
      checkwmfpen; checkwmfbrush;
      rop2wmf(r2_maskpen);
      if (mode=2) then polygonwmf(poly)
        else ellipsewmf(x-r,y-r,x+r+1,y+r+1);
      rop2wmf(r2_copypen);
      if edge then
        begin
          xybrush.style := bsclear;
          checkwmfbrush;
          if (mode=2) then polygonwmf(poly)
            else ellipsewmf(x-r,y-r,x+r+1,y+r+1);
          xybrush.style := bssolid;
        end;
      exit;
    end;

  if (transmode>1) then
    begin
      if (mode=2) then h := createpolygonrgn(poly,length(poly),alternate)
        else h := createellipticrgn(x-r,y-r,x+r+1,y+r+1);
      if (h<>0) then transparent(h,col2,edge);
      deleteobject(h);
    end;

  if (transmode=1) or (h=0) then
    begin
      setrop2(xycanvas.handle,r2_maskpen);
      if (mode=2) then xycanvas.polygon(poly)
       else xycanvas.ellipse(x-r,y-r,x+r+1,y+r+1);
      setrop2(xycanvas.handle,r2_copypen);
    end;

  if edge then
    begin
      xybrush.style := bsclear;
      if (mode=2) then xycanvas.polygon(poly)
       else xycanvas.ellipse(x-r,y-r,x+r+1,y+r+1);
      xybrush.style := bssolid;
    end;
  xybrush.color := col2;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure printpart(x1,y1,x2,y2:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type regel = array[0..8000] of integer;
     pregel = ^regel;
var x,y,xp,yp,xx,xxp,pw,xp0,yp0 : integer;
    col : Tcolor;
    buf : pregel;
begin
  pw := xypen.width; xypen.width := 1;
  xp0 := prxoff - prfac div 2; yp0 := pryoff - prfac div 2;
  if (not doprint) and prshow then xypen.mode := pmnot;
  for y := y1 to y2 do
    begin
     if not doprint then
       if prshow then with xycanvas do begin moveto(x1,y); lineto(x2,y); end;
     buf := screencopy.scanline[y]; yp := yp0 + y * prfac; x := x1;
     while (x<=x2) do
      begin
       col := buf[x];
       if (col<>clwhite) then
         begin
          xx := x; while(xx<x2) and (buf[xx+1]=col) do inc(xx);
          xp := xp0 + x * prfac; xxp := xp0 + xx * prfac;
          printer.canvas.brush.color := reversecolor(col);
          printer.canvas.pen.color := printer.canvas.brush.color;
          printer.canvas.rectangle(xp,yp,xxp+prfac,yp+prfac);
          x := xx;
         end;
       inc(x);
     end;
   end;
   xypen.mode := pmcopy;
   xypen.width := pw;
end;

procedure copyscreen(mode:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var w,h : integer;
    crect : Trect;
begin
  screencopy := Tbitmap.create;
  w := cwidth; h := cheight;
  with screencopy do
    begin
      if (mode=1) then pixelformat := pf24bit else
      if (mode=2) then pixelformat := pf32bit;
      width := w; height := h;
      crect := rect(0,0,w,h);
      canvas.copymode := cmSrcCopy;
      canvas.copyrect(crect,xycanvas,crect);
    end;
end;

procedure restorescreen; {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var crect : Trect;
begin
   with screencopy do crect := rect(0,0,width,height);
   xycanvas.copyrect(crect,screencopy.canvas,crect);
   screencopy.free;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXX EX XYGRAF XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure store; begin oldpen.assign(xypen); oldbrush.assign(xybrush); end;
procedure restore; begin xypen.assign(oldpen); xybrush.assign(oldbrush); end;

procedure setcursor(xp,yp:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  {xp := (xp*res)+xoff; yp := (yp*res)+yoff;}
  if dowmf then movewmf(xp,yp) else xycanvas.moveto(xp,yp);
end;

procedure setorigin(x,y:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  with xycanvas do
    begin
      unrealizeobject(brush.handle);
      setbrushorgex(handle,x,y,nil);
      selectobject(handle,brush.handle);
    end;
end;

procedure xypixel(xp,yp:integer;col:Tcolor); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var df1,df2 : integer;
begin
  if (res=1) then
    if dowmf then pixelwmf(xp,yp,col)
         else xycanvas.pixels[xp,yp] := col
  else
    begin
      store; xypen.width := 1; xybrush.style := bssolid;
      df1 := res div 2; df2 := res-df1;
      xyrectangle(col,col,xp-df1,yp-df1,xp+df2,yp+df2);
      restore;
    end;
end;

procedure xyrectangle(col1,col2,x1,y1,x2,y2:integer); {XXXXXXXXXXXXXXXXXXXXXXXX}
begin
  if (col2>=0) then
    begin
     xybrush.color := col2;
     if (col1<0) then xypen.color := col2 else xypen.color := col1;
    end;
  if dowmf then
    begin checkwmfpen; checkwmfbrush; blokwmf(x1,y1,x2,y2); end
  else xycanvas.rectangle(x1,y1,x2,y2);
end;

procedure xypolygon(col1,col2:integer;poly:array of Tpoint); {XXXXXXXXXXXXXXXXX}
begin
  if (col2>=0) then
    begin
     xybrush.color := col2;
     if (col1<0) then xypen.color := col2 else xypen.color := col1;
    end;
  if dowmf then
    begin checkwmfpen; checkwmfbrush; polygonwmf(poly); end
  else xycanvas.polygon(poly);
end;

procedure transpolygon(col1,col2:integer;poly:array of Tpoint); {XXXXXXXXXXXXXX}
begin
  if (col2>=0) then
    begin
     xybrush.color := col2;
     if (col1<0) then xypen.color := col2 else xypen.color := col1;
    end;
  drawtransparent(0,0,0,poly);
end;

procedure xycircle(col1,col2,x,y,r:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  if (col2>=0) then
    begin
     xybrush.color := col2;
     if (col1<0) then xypen.color := col2 else xypen.color := col1;
    end
  else if (col1>=0) then xypen.color := col1;
  if dowmf then
    begin checkwmfpen; checkwmfbrush; ellipsewmf(x-r,y-r,x+r+1,y+r+1); end
  else xycanvas.ellipse(x-r,y-r,x+r+1,y+r+1);
end;

procedure transcircle(col1,col2,x,y,r:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  if (col2>=0) then
    begin
     xybrush.color := col2;
     if (col1<0) then xypen.color := col2 else xypen.color := col1;
    end;
  drawtransparent(x,y,r,[]);
end;

procedure xyline(col,x1,y1,x2,y2:integer); {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
  if (col>=0) then xypen.color := col;
  if dowmf then begin checkwmfpen; linewmf(x1,y1,x2,y2); end
  else begin xycanvas.moveto(x1,y1); xycanvas.lineto(x2,y2); end;
end;
(*
Procedure CanvasTextOutAngle(C:TCanvas; X,Y:Integer; Angle:Word; S:String);
Var
  LogRec: TLOGFONT;
  OldFontHandle,
  NewFontHandle: HFONT;
Begin
  GetObject(C.Font.Handle,SizeOf(LogRec),Addr(LogRec));
  LogRec.lfEscapement:=Angle*10; {10th of a degree}
  LogRec.lfOrientation:=Angle*10;
  NewFontHandle := CreateFontIndirect(LogRec);
  OldFontHandle := SelectObject(C.Handle,NewFontHandle);
  C.Brush.Style := bsClear;
  C.TextOut(X,Y,S);
  NewFontHandle := SelectObject(C.Handle,OldFontHandle);
  DeleteObject(NewFontHandle);
End; *)

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXX EX WMF XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

const buflen = 64;

var fn : file;
    buf : array[1..buflen] of word;
    bufd : array[1..buflen div 2] of cardinal absolute buf;
    flsize, maxlen, nobj, ppx, ppy : integer;
    fnaam : string;

    ok : boolean;

procedure dosize(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  inc(flsize,n);
  if (n>maxlen) then maxlen := n;
end;

procedure dorecord;
begin
  blockwrite(fn,buf,bufd[1]);
  dosize(bufd[1]); ppx := -1;
end;

procedure fillintext(s:string; pos:integer; nul:boolean); {WWWWWWWWWWWWWWWWWWWW}
var i : integer;
begin
  if (s='') then s := ' ';
  if nul then s := s + #0;
  if odd(length(s)) then s := s + #32;
  for i := 1 to length(s) div 2 do
    begin
      buf[pos] := ord(s[i*2-1]) + ord(s[i*2]) shl 8;
      bufd[1] := pos;
      inc(pos);
    end;
end;

procedure fillincolor(color:Tcolor; pos:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  buf[pos] := red(color) + green(color) shl 8;
  buf[pos+1] := blue(color) + 2 shl 8;
  buf[pos+2] := 0;
end;

procedure startwmf(var s:string;var ok : boolean); {WWWWWWWWWWWWWWWWWWWWWWWWWWW}
var i : integer;
begin
  s := changefileext(s,'.wmf');
  fnaam := s;
  assignfile(fn,s); rewrite(fn,2);
  ok := (ioresult=0);  
  if ok then
   begin
     for i := 1  to 20 do buf[i] := 0;
     blockwrite(fn,buf,11+9);
     flsize := 20; maxlen := 0; nobj := 5;
    end;
end;

procedure bitmap(name:string; xp,yp:integer; fac:single); {WWWWWWWWWWWWWWWWWWWW}
var width,height : integer;
    p1,p2,t,len : integer;
begin
  assignfile(ff,name); reset(ff,2); if (ioresult<>0) then exit;
  seek(ff,8); blockread(ff,buf,4); width := buf[2]; height := buf[4];
  seek(ff,7);

(*  bufd[1] := 4; buf[3] := $0107; buf[4] := 3; dorecord; {SetStretchBltMode} *)

  p1 := filepos(fn);
  bufd[1] := 00; buf[3] := $0F43;  {StretchDIBits}
  buf[4] := 32; buf[5] := 204; buf[6] := 0; {standaard header?}
  buf[7] := height; buf[8] := width;
  buf[9] := 0; buf[10] := 0;
  if (fac<1.5) then
    begin buf[11] := round(height*fac); buf[12] := round(width*fac); end
  else
  begin buf[11] := round(height*fac-fac/2); buf[12] := round(width*fac-fac/2); end;
  buf[13] := yp; buf[14] := xp;
  blockwrite(fn,buf,14);

  repeat blockread(ff,buf,buflen,t); blockwrite(fn,buf,t) until (t<buflen);

  p2 := filepos(fn); len := (p2-p1);
  seek(fn,p1); bufd[1] := len; blockwrite(fn,buf,2); seek(fn,p2);
  inc(flsize,len); if (len>maxlen) then maxlen := len;

  closefile(ff);
end;

procedure finishwmf(x,y,inch:integer;var ok:boolean); {WWWWWWWWWWWWWWWWWWWWWWWW}
var csum,i  : integer;
begin
  bufd[1] := 3; buf[3] := 0; dorecord;  {EOF}

  bufd[1] := $9AC6CDD7;    {Aldus header}
  buf[3] := 0;
  buf[4] := 0; buf[5] := 0;
  buf[6] := x; buf[7] := y;
  buf[8] := inch;
  buf[9] := 0; buf[10] := 0;
  csum := 0; for i := 1 to 10 do csum := csum xor buf[i];
  buf[11] := csum;
  seek(fn,0); blockwrite(fn,buf,11);

  buf[1] := 1;             {standard header}
  buf[2] := 9;
  buf[3] := $300;
  buf[4] := flsize and 65535;  buf[5] := flsize shr 16;
  buf[6] := nobj;
  buf[7] := maxlen and 65535; buf[8] := maxlen shr 16;
  buf[9] := 0;
  blockwrite(fn,buf,9);
  closefile(fn);

  ok := fileexists(fnaam);
  if ok then
    begin
      assignfile(fn,fnaam); reset(fn,1);
      ok := (filesize(fn)=flsize*2); closefile(fn);
    end;
end;

procedure setsize(x,y:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $0103; buf[4] := 8; dorecord; {Mapmode};
  bufd[1] := 5; buf[3] := $020B; buf[4] := 0; buf[5] := 0; dorecord; {Windoworg}
  bufd[1] := 5; buf[3] := $020C; buf[4] := y; buf[5] := x; dorecord; {Windowext}
end;

procedure setemptybrush; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 7; buf[3] := $02FC; buf[4] := 1;
  buf[5] := 0; buf[6] := 0; buf[7] := 0;
  dorecord; {createbrushindirect}
end;

procedure setbrush(style:integer;color:Tcolor); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 7; buf[3] := $02FC; buf[4] := style;
  fillincolor(color,5); dorecord; {createbrushindirect}
end;

procedure textcolor(color:Tcolor); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 5; buf[3] := $0209;
  fillincolor(color,4); dorecord; {settextcolor}
end;

procedure setfont(he,wi,an:integer;font:Tfont); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var s : string;
begin
  bufd[1] := 0; buf[3] := $02FB;
  buf[4] := word(he); buf[5] := wi;
  buf[6] := an*10; buf[7] := an*10;
  if fsbold in font.style then buf[8] := 700 else buf[8] := 400;
  buf[9] := 0; if fsitalic in font.style then buf[9] := 1;
  if fsunderline in font.style then buf[9] := buf[9] + 256;
  buf[10] := 0; if fsstrikeout in font.style then buf[10] := 1;
  buf[10] := buf[10] + 1*256;
  buf[11] := 0 + 0*256;
  buf[12] := 0 + 0*256;
  s := font.name; fillintext(s,13,true);
  dorecord; {createfontindirect}

  textcolor(font.color);
end;

procedure extrachar(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $0108; buf[4] := n; dorecord; {settextcharextra}
end;

procedure textalign(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $012E; buf[4] := n; dorecord; {settextalign}
  (*   0   6   2
      24  30  26
       8  14  10 *)
end;

procedure textout(x,y:integer;txt:string); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 0; buf[3] := $0521; buf[4] := length(txt);
  fillintext(txt,5,false); inc(bufd[1],2);
  buf[buf[1]-1] := y; buf[bufd[1]] := x; dorecord; {textout}

  exit;
  bufd[1] := 0; buf[3] := $0A32; buf[4] := y; buf[5] := x;
  buf[6] := length(txt); buf[7] := 0; fillintext(txt,8,false);
  dorecord; {exttextout}
end;

procedure setpen(style,wi:integer; color:Tcolor); {WWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 9; buf[3] := $02FA; buf[4] := style; buf[5] := wi; buf[6] := 0;
  fillincolor(color,7); dorecord; {createpenindirect}
end;

procedure selectobject(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $012D; buf[4] := n; dorecord; {selectobject}
end;

procedure deleteobject(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $01F0; buf[4] := n; dorecord; {deleteobject}
end;

procedure blokwmf(x1,y1,x2,y2:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 7; buf[3] := $041B;
  buf[4] := y2; buf[5] := x2; buf[6] := y1; buf[7] := x1;
  dorecord; {rectangle};
end;

procedure ellipse(x1,y1,x2,y2:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 7; buf[3] := $0418;
  buf[4] := y2; buf[5] := x2; buf[6] := y1; buf[7] := x1;
  dorecord; {ellipse};
end;

procedure bkmode(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $0102; buf[4] := n; dorecord; {setbkmode}
end;

procedure rop2(n:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 4; buf[3] := $0104; buf[4] := n; dorecord; {setrop2}
end;

procedure comment(txt:string); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 0; buf[3] := $0626; buf[4] := 15;
  buf[5] := length(txt); fillintext(txt,6,false);
  dorecord; {escape};
end;

procedure movewmf(x,y:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  if (ppx=x) and (ppy=y) then exit;
  bufd[1] := 5; buf[3] := $0214; buf[4] := y; buf[5] := x;
  dorecord; {moveto};
  ppx := x; ppy := y;
end;

procedure drawwmf(x,y:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  if (ppx=x) and (ppy=y) then exit;
  bufd[1] := 5; buf[3] := $0213; buf[4] := y; buf[5] := x;
  dorecord; {lineto};
  ppx := x; ppy := y;
end;

procedure pixel(x,y:integer;color:Tcolor); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  bufd[1] := 7; buf[3] := $041F; fillincolor(color,4);
  buf[6] := y; buf[7] := x; dorecord; {setpixel};
end;

procedure polygon(points: array of Tpoint); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var i,n : integer;
begin
  n := length(points);
  bufd[1] := n*2+4; buf[3] := $0324; buf[4] := n;
  for i := 1 to n do
    begin
      buf[i*2+3] := points[i-1].x;
      buf[i*2+4] := points[i-1].y;
    end;
  dorecord; {polygon};
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXX EX XYWMF XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

var penwidth : integer;
    penstyle : integer;
    pencolor,redcolor,grncolor : Tcolor;
    fontcolor : Tcolor;
    fontsize : integer;
    fontstyle: Tfontstyles;
    fontangle : integer;
    brushcolor : Tcolor;
    brushstyle : integer;

    cgrid,fgrid : array of word;
    ncgrid,nfgrid : integer;

procedure initgrid; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  setlength(cgrid,0); setlength(fgrid,0);
  ncgrid := 0; nfgrid := 0;
end;

procedure addcoarse(p:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  inc(ncgrid); setlength(cgrid,ncgrid);
  cgrid[ncgrid-1] := p;
end;

procedure addfine(p:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  inc(nfgrid); setlength(fgrid,nfgrid);
  fgrid[nfgrid-1] := p;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure checkwmfpen; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  if stereo then exit;
  with xycanvas.pen do
    if (color<>pencolor) or (integer(style)<>penstyle) or (width<>penwidth) then
      begin
        deleteobject(1);
        setpen(integer(style),width,color);
        selectobject(1);
        pencolor := color;
        penstyle := integer(style);
        penwidth := width;
      end;
end;

procedure checkwmfrgpen; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  with xycanvas.pen do
    if (redcolor<>stereocol[1]) or (grncolor<>stereocol[2])
     or (integer(style)<>penstyle) or (width<>penwidth) then
      begin
        deleteobject(4);
        setpen(integer(style),width,stereocol[2]);
        selectobject(4);
        deleteobject(3);
        setpen(integer(style),width,stereocol[1]);
        selectobject(3);
        redcolor := stereocol[1]; grncolor := stereocol[2];
        penstyle := integer(style);
        penwidth := width;
      end
   else selectobject(3);
end;

procedure wmfredpen; begin selectobject(3); end;
procedure wmfgrnpen; begin selectobject(4); end;

procedure fontwmf; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var h,w,e : integer;
begin
  with xycanvas.font do
    begin
      h := height;
      if name = 'Small Fonts' then
         begin w := 0; e := size div 3; if fsbold in style then inc(e); end
      else
      if name = 'Arial' then
        begin w := round(xycanvas.textwidth('0')*0.85); e := 0; end
      else
      {if name = 'MS Sans Serif' then}
        begin w := 0; e := size div 3; if fsbold in style then inc(e); end;
    end;
  setfont(h,w,xyfontangle,xycanvas.font);
  extrachar(e);
end;

procedure checkwmffont; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  with xycanvas.font do
    if (style<>fontstyle) or (size<>fontsize) or (xyfontangle<>fontangle) then
      begin
        deleteobject(2);
        fontwmf;
        selectobject(2);
        fontcolor := color;
        fontstyle := style;
        fontsize := size;
        fontangle := xyfontangle;
      end
    else if (color<>fontcolor) then
      begin
        textcolor(color);
        fontcolor := color;
      end;
end;

procedure checkwmfbrush; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  with xycanvas.brush do
    if (color<>brushcolor) or (integer(style)<>brushstyle) then
      begin
        deleteobject(0);
        setbrush(integer(style),color);
        selectobject(0);
        brushcolor := color;
        brushstyle := integer(style);
      end;
end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

procedure openwmf(var s:string;var ok:boolean); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
begin
  if (s='') then s := 'xygraf.wmf';
  startwmf(s,ok);
  dowmf := ok; ppx := -1;
end;

procedure initwmf; {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var x,y : integer;
begin
  x := xypaintbox.width*res; y := xypaintbox.height*res;
  redcolor := $0000ff; grncolor := $00ff00;
  comment('File created by XYGRAF');
  comment('(C) Wilko C Emmens 2002');
  setsize(x,y);
  setbrush(0,backcolor);
    brushcolor := backcolor; brushstyle := 0;
  selectobject(0);
  setpen(0,1,frontcolor);
    pencolor := frontcolor; penstyle := 0; penwidth := 1;
  selectobject(1);
  fontwmf;
    fontsize := xycanvas.font.size;
    fontcolor := xycanvas.font.color;
    fontstyle := xycanvas.font.style;
  selectobject(2);
  setpen(0,1,redcolor); selectobject(3);
  setpen(0,1,grncolor); selectobject(4);
  selectobject(1);
  bkmode(1);
end;

procedure pixelwmf(x,y:integer; col:Tcolor); begin pixel(x,y,col); end;
procedure linewmf(x1,y1,x2,y2:integer); begin movewmf(x1,y1); drawwmf(x2,y2); end;

procedure textwmfalign(n:integer); begin textalign(n); end;
procedure textwmfout(x,y:integer;s:string); begin textout(x,y,s); end;

procedure ellipsewmf(x1,y1,x2,y2:integer); begin ellipse(x1,y1,x2,y2); end;

procedure rop2wmf(n:integer); begin rop2(n); end;

procedure polygonwmf(points: array of Tpoint);
begin polygon(points); end;

procedure closewmf(var ok:boolean); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var x,y : integer;
begin
  x := xypaintbox.width*res; y := xypaintbox.height*res;
  finishwmf(x,y,screen.pixelsperinch,ok);
  dowmf := false;
end;

procedure dogrid(p1,p2:integer;xas:boolean); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var i : integer;
    col : Tcolor;
begin
  xycanvas.pen.style := psdot; col := xycanvas.pen.color;
  if (nfgrid>0) then
    begin
      xycanvas.pen.color := mixcolor(col,backcolor,1,3);
      checkwmfpen;
      for i := 0 to nfgrid-1 do
        if xas then linewmf(fgrid[i],p1,fgrid[i],p2)
               else linewmf(p1,fgrid[i],p2,fgrid[i]);
    end;
  if (ncgrid>0) then
    begin
      xycanvas.pen.color := col;
      checkwmfpen;
      for i := 0 to ncgrid-1 do
        if xas then linewmf(cgrid[i],p1,cgrid[i],p2)
               else linewmf(p1,cgrid[i],p2,cgrid[i]);
    end;
  xycanvas.pen.style := pssolid;
  xycanvas.pen.color := col;
end;

procedure bitmapwmf(x1,y1,x2,y2:integer); {WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW}
var bmp : Tbitmap;
    crect1,crect2 : Trect;
    ok : boolean;
    s : string;
begin
  s := 'tempfile.bmp';
  screen.cursor := crhourglass;
  bmp := Tbitmap.create; ok := true;
  with bmp do
    begin
      pixelformat := screencopy.pixelformat;
      width := x2-x1+1; height := y2-y1+1;
      crect1 := rect(x1,y1,x2+1,y2+1);
      crect2 := rect(0,0,x2-x1+1,y2-y1+1);
      canvas.copymode := cmSrcCopy;
      canvas.copyrect(crect2,screencopy.canvas,crect1);
      try    savetofile(s);
      except ok := false;
      end;
      free;
    end;
  if ok then
    begin
      bitmap(s,x1*res,y1*res,res);
      deletefile(s);
    end;
  screen.cursor := crdefault;
end;

begin
  xyfontangle := 0;
end.
