unit xyun;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, AppEvnts, Buttons;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    Button3: TButton;
    StatusBar1: TStatusBar;
    ApplicationEvents1: TApplicationEvents;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    TabSheet3: TTabSheet;
    PaintBox3: TPaintBox;
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses xygraph, xycopy;

var res,err : array[1..12] of integer;
    labels : array of string;
    d0,d1,dd : double;
    y,m,d,h,n,s,ms : word;
    dmin : double;
    ystring : string;

{$R *.DFM}

(* This program is a test program for XYGRAPH. It demonstrates many
   options of XYGRAPH (but not all). Experiment with it; change parameters
   and see what the effect is. Add procedure calls.
   Or in other words: enjoy yourself.

   Please refer to XYGRAPH.HLP for descriprion of all procedures.

   The use of the PRINT&COPY form is explained in the unit XYCopy.pas *)

function sinx(x:single):single; begin sinx := sin(x); end;
function sinx2(x:single):single; begin sinx2 := sin(sqr(x)); end;

const nspokes=6;
var axes : array[0..nspokes-1] of Tradar;
    bdata : array of Tbardata;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var i,y,e : integer;
    logscale : boolean;
begin
   logscale := checkbox1.checked;

   xycleargraph(paintbox1,clwhite,clblack,8/8);

   { - - - first graph - - - }

   xystartgraph(0,50,0,65,40,70,50,40,clipon);

   xyxaxis(clblack,1,100,0,0,'X-axis',gridoff,logscale,fixed);
   xyyaxis(clblack,1,100,0,0,'@First',1,gridoff,logscale,fixed);

   xymove(0,0); for i := 1 to 9 do
     begin xydraw(i*10,i*10); xysymbol(1,0,1); end;
   if logscale then xylegendentry(3,'symb 1')
               else xylegendentry(0,'line 1');

   xysetlinestyle(16,0,0);
   xyyaxis(clblue,1,10,0,0,'Second',2,gridoff,logscale,fixed);
   xylinewidth(1);
   xymove(0,0); for i := 1 to 9 do
     begin xydraw(i*10,i*10); xysymbol(2,8,1); end;
   if logscale then xylegendentry(3,'symb 2')
               else xylegendentry(0,'line 2');
   xysetlinestyle(0,0,0);

   xyyaxis(clgreen,1,10000,0,0,'Third',3,gridoff,logscale,fixed);
   xylinewidth(2);
   xymove(0,0); for i := 1 to 9 do
     begin xydraw(i*10,i*10); xysymbol(3,8,0); end;
   if logscale then xylegendentry(3,'symb 3')
               else xylegendentry(0,'line 3');
   xylinewidth(1);

   xyyaxis(clred,1,1000,0,0,'@Fourth',4,gridoff,logscale,fixed);
   xymove(0,0); for i := 1 to 9 do
     begin xydraw(i*10,i*10); xysymbol(4,8,2); end;
   if logscale then xylegendentry(3,'symb 4')
               else xylegendentry(0,'line 4');  
   xytitle(clgray,'GRAPH 1');

   { - - - second graph - - - }

   xystartgraph(50,100,0,65,70,10,30,20,clipon);
   if checkbox1.checked then xylabelaxis(clblack,labels,gridoff)
     else xyyearaxis(clblack,3,0,gridoff);
   xyyaxis(clblack,0,180,0,0,'Results',1,gridon,lin,fixed);
   if logscale then
     begin
       xypen.color := clfuchsia;
       for i := 1 to 12 do
         begin
           y := res[i]; e := err[i];
           if (i=1) then xymove(i,y) else xydraw(i,y);
           xyerrorbar(i,y,0,0.4,0.4,e*2,-e*2,e,-e,rel,userc,0);
         end;
       xylegendentry(4,'errbar');
       {xysegbar(-1,5,0.5,0,0,false,bdata);}
     end
   else
     begin
       for i := 1 to 12 do xybar(clfuchsia,i,0.7,res[i],0);
       xylegendentry(1,'bar');
     end;

   xytitle(clgray,'GRAPH 2');

   { - - - third graph - - - }

   xystartgraph(0,100,65,100,35,55,20,25,clipon);
   if checkbox1.checked then xysetratio(1);
   xyxaxis(clblack,-10,10,0,0,'',gridoff,logscale,fixed);
   xyyaxis(clblack,-1.05,1.05,0,0,'sine functions',5,gridoff,logscale,fixed);
   xylinewidth(2);
   xysetlinestyle(15,60,2);
   xydrawfunction(4,sinx);
   xypen.color := clred;
   xylinewidth(1);
   xysetlinestyle(0,0,0);
   xydrawfunction(0,sinx2);

   xyfinish;

   xytitle(clgray,'GRAPH 3');

   { - - - additional instructions - - - }

   xylegendmake(3,paintbox1.width div 2,4,0,1,
     0,round(paintbox1.height*0.55),0,frameon);

   xysetusercoordinates(0,0);
   xytextangle(clblack,'XYGRAPH|(C) 2002',paintbox1.width-10,
     round(paintbox1.height*0.82),0,1,3,-90);

   xyinitruler(clgray,20,round(paintbox1.height*0.65)-xycharheight div 2,1);
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
var i : integer;
begin
   xycleargraph(paintbox2,clwhite,clblack,8/8);

   xystartgraph(0,50,0,100,40,40,40,40,clipon);
   if checkbox1.checked then
        xypolargraph(clmaroon,1,2,90,0,reverse,angle,gridon,true)
   else xypolargraph(clmaroon,1,2, 0,0,normal,straight,gridon,true);
   xypen.color := clblue; xylinewidth(2);
   xymove(0,1); for i := 1 to 100 do xydraw(1+i/100,i*10);
   xytitle(clgray,'POLAR GRAPH');

   xystartgraph(50,100,0,100,40,40,40,40,clipon);
   if checkbox1.checked then
        xyradargraph(clnavy,axes,2,90,1,normal,straight,sci,0)
   else xyradargraph(clnavy,axes,0,90,1,normal,straight,sci,0);
   xylinewidth(2);
   xypen.color := clred; xyradardraw([0.5,1,1.5,2,2.5],1,1);
   xypen.color := clgreen; xyradardraw([0.8,0.8,0.8,0.8,0.8],1,2);
   xypen.color := clblue; xyradardraw([0.5,1,0.5,1,0.5,1,0.5,1],1,2);
   xytitle(clgray,'RADAR GRAPH');

   xyfinish;
   xyinitruler(clblack,paintbox2.width div 2,paintbox2.height-16,1);
end;

procedure TForm1.PaintBox3Paint(Sender: TObject);
var i : integer;
    tm : boolean;
begin
 xycleargraph(paintbox3,clwhite,clblack,1.0);
 if checkbox1.checked then
   begin
     dmin := 1;
     xystartgraph(0,100,0,100,30,20,30,60,clipon);
     xytimeaxis(clblack,d0-dd,d0+dd,'date',0,0,0,0,1,false,tm);
   end
 else
   begin
     dmin := 1/24/60/60;
     xystartgraph(0,100,0,100,30,20,30,50,clipon);
     xytimeaxis(clblack,d0-dd,d0+dd,'date|time and date '+ystring,-1,1,1,1,2,false,tm);
   end;
 xyyaxis(clblack,0,100,0,0,'',1,gridoff,lin,fixed);
 xymove(d0,0); xydraw(d0,100);
 d1 := encodedate(y,m,d)+encodetime(h,n,s,0); xymove(d1,0); xydraw(d1,90);
 d1 := encodedate(y,m,d)+encodetime(h,n,0,0); xymove(d1,0); xydraw(d1,80);
 d1 := encodedate(y,m,d)+encodetime(h,0,0,0); xymove(d1,0); xydraw(d1,70);
 d1 := encodedate(y,m,d); xymove(d1,0); xydraw(d1,60);
 d1 := encodedate(y,m,1); xymove(d1,0); xydraw(d1,50);
 d1 := encodedate(y,1,1); xymove(d1,0); xydraw(d1,40);
 d1 := encodedate(2000,1,1); xymove(d1,0); xydraw(d1,30);
 d1 := encodedate(1900,1,1); xymove(d1,0); xydraw(d1,20);
 xytitle(clmaroon,'TimeAxis demo, press + to zoom in, - to zoom out, ENTER to reset');
 xyinitruler(clblack,4,4,1);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin xymousedown(button,shift,x,y); end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin xymousemove(shift,x,y); end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin xymouseup(button,shift,x,y); end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  xykeydown(key,shift);
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : integer;
begin
  randomize; for i := 1 to 12 do res[i] := 100 + random(50);
  for i := 1 to 12 do err[i] := 5 + random(10);
  setlength(labels,12); for i := 0 to 11 do labels[i] := inttostr(i+1);
  checkbox1.hint := '|change to: graph 1: log scale, symbol legend; graph 2: labelaxis, errorbar; graph 3: fixed Y/X ratio';
  button3.hint := '|print, copy or save graph';
  paintbox1.hint := '|graph area; click for ruler function; control-click to zoom';
  paintbox2.hint := '|graph area; click for ruler function; control-click to zoom';
  paintbox3.hint := '|graph area; click for ruler function; control-click to zoom';
  for i := 1 to nspokes do with axes[i-1] do
    begin txt := 'Nr. '+inttostr(i); mi := 0; ma := i; end;
  setlength(bdata,3);
  with bdata[0] do begin ypos := 20; col := clred; end;
  with bdata[1] do begin ypos := 30; col := clgreen; end;
  with bdata[2] do begin ypos := 40; col := clblue; end;
  d0 := date+time; dd := 1; decodedate(d0,y,m,d); decodetime(d0,h,n,s,ms);
  ystring := '('+inttostr(y)+')';
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  xyunzoom;
  if (pagecontrol1.activepage=tabsheet1) then paintbox1.repaint else
  if (pagecontrol1.activepage=tabsheet2) then paintbox2.repaint
  else
    begin if (dd<dmin) then dd := dmin; paintbox3.Repaint; end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin xycopystart; end;

procedure TForm1.ApplicationEvents1Hint(Sender: TObject);
begin
  statusbar1.simpletext := application.hint;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if (pagecontrol1.activepage=tabsheet1) then
  checkbox1.hint := '|change to: graph 1: log scale, symbol legend; graph 2: labelaxis, errorbar; graph 3: fixed Y/X ratio'
  else if (pagecontrol1.activepage=tabsheet2) then
  checkbox1.hint := '|change: polar: reverse, orientation, angle;  radar: frame style (equal axes)'
  else
  checkbox1.hint := '|change: mode and date/time presentation';
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if not (pagecontrol1.activepage=tabsheet3) then exit;
  if (key='-') then
    begin if (dd<dmin) then dd := dmin; dd := dd * 1.02; paintbox3.refresh; end;
  if (key='+') then begin dd := dd / 1.02; paintbox3.refresh; end;
  if (key=#13) then begin dd := 1; paintbox3.refresh; end;
end;

end.
